% open Lena image and convert from uint8 to double
pic_data_rgb = double(imread('ScrollWave.png'));
%pic_data_gray = rgb2gray(pic_data_rgb);

% perform SVD on Lena
%[U,S,V] = svd(pic_data_gray);
[U1,S1,V1] = svd(pic_data_rgb(:,:,1));
[U2,S2,V2] = svd(pic_data_rgb(:,:,2));
[U3,S3,V3] = svd(pic_data_rgb(:,:,3));

% extract singular values
%singvals = diag(S);
singvals1 = diag(S1);
singvals2 = diag(S2);
singvals3 = diag(S3);

% find out where to truncate the U, S, V matrices
sv_tol = 0.1;
%indices = find(singvals >= sv_tol * singvals(1));
indices1 = find(singvals1 >= sv_tol * singvals1(1));
indices2 = find(singvals2 >= sv_tol * singvals2(1));
indices3 = find(singvals3 >= sv_tol * singvals3(1));

k = max([length(indices1),length(indices2),length(indices3)]);
if length(indices1)==k
  indices=indices1;
  singvals=singvals1;
elseif length(indices2)==k
  indices=indices2;
  singvals=singvals2;
else
  indices=indices3;
  singvals=singvals3;
end

% reduce SVD matrices
%U_red = U(:,indices);
%S_red = S(indices,indices);
%V_red = V(:,indices);
U1_red = U1(:,indices);
S1_red = S1(indices,indices);
V1_red = V1(:,indices);
U2_red = U2(:,indices);
S2_red = S2(indices,indices);
V2_red = V2(:,indices);
U3_red = U3(:,indices);
S3_red = S3(indices,indices);
V3_red = V3(:,indices);

% construct low-rank approximation of ScrollWave
%ScrollWave_red = U_red * S_red * V_red';
ScrollWave_red_col(:,:,1) = U1_red * S1_red * V1_red';
ScrollWave_red_col(:,:,2) = U2_red * S2_red * V2_red';
ScrollWave_red_col(:,:,3) = U3_red * S3_red * V3_red';

% print results to command window
r = num2str(length(indices));
m = num2str(length(singvals));
disp(['Low-rank approximation used ',r,' of ',m,' singular values']);

% save reduced Lena
imshow(uint8(ScrollWave_red_col));
imwrite(uint8(ScrollWave_red_col),'ReducedScrollWaveColor.png');

% save color data of reduced pic (ScrollWave_red=W_red*Z_red)
W1 = U1_red * sqrt(S1_red);
Z1 = sqrt(S1_red) * V1_red';
W2 = U2_red * sqrt(S2_red);
Z2 = sqrt(S2_red) * V2_red';
W3 = U3_red * sqrt(S3_red);
Z3 = sqrt(S3_red) * V3_red';
%W=uint8(W); Z=uint8(Z);
save('data_red_color.mat','W1','Z1','W2','Z2','W3','Z3');

% save color data of original pic
W1 = U1_red * sqrt(S1_red);
Z1 = sqrt(S1_red) * V1_red';
W2 = U2_red * sqrt(S2_red);
Z2 = sqrt(S2_red) * V2_red';
W3 = U3_red * sqrt(S3_red);
Z3 = sqrt(S3_red) * V3_red';
%W=uint8(W); Z=uint8(Z);
save('data_red_color.mat','W1','Z1','W2','Z2','W3','Z3');


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Improve image quality
[n1,m1]=size(ScrollWave_red_col(:,:,1));
B1=zeros(n1*(n1-1),m1*(m1-1));
for i=1:n1
    for j=1:n1
    end
end
